/*************************************  Android *************************/
import android.content.Intent;
import android.os.Bundle;
import ketai.net.bluetooth.*;
import ketai.ui.*;
import ketai.net.*;
import android.view.MotionEvent;  

boolean isConfiguring = true;
KetaiBluetooth bt;
KetaiList klist;
ArrayList devicesDiscovered = new ArrayList();
KetaiGesture gesture;  
String infoBT = "";


void onCreate(Bundle savedInstanceState) {
 super.onCreate(savedInstanceState);
 bt = new KetaiBluetooth(this);
}

void onActivityResult(int requestCode, int resultCode, Intent data) {
 bt.onActivityResult(requestCode, resultCode, data);
}

void onKetaiListSelection(KetaiList klist) {
 String selection = klist.getSelection();
 bt.connectToDeviceByName(selection);
 klist = null;
}

void onBluetoothDataEvent(String who, byte[] data) {
 String st; 
  if (isConfiguring)
 return;
   st = new String(data);  // receive Data
  for (int i=0;i<st.length();i++)
   {
  infoBT+=st.charAt(i)   ;
   } 
  if (infoBT.length()>200) infoBT="";   // limite la taille du texte
}

void onTap(float x, float y)  
{
  commande();
}

void onDoubleTap(float x, float y)  
{
// idem mouseCliked
}

void onFlick( float x, float y, float px, float py, float v)  
{
  // moved mouse
}

public boolean surfaceTouchEvent(MotionEvent event) {  
  super.surfaceTouchEvent(event);
  return gesture.surfaceTouchEvent(event);
}

char SerialRead(){
  char a;
  a=infoBT.charAt(0);
  String infoBT2; 
  infoBT2 = new String(); 
  infoBT2="";
  for (int i=1;i<infoBT.length();i++)
   {
     infoBT2+=infoBT.charAt(i)   ;
   }  
 infoBT=infoBT2;
 return a;
} 

int BT_ava(){
  int i=0;
//  if ( infoBT.length()>20) i= infoBT.length();
  if ( infoBT.length()>20) i=1;
  return i;
}

void initBT()
{
  gesture = new KetaiGesture(this);  
  bt.start();
  isConfiguring = true;
  if (isConfiguring)
 {
  ArrayList names;
  klist = new KetaiList(this, bt.getPairedDeviceNames());
  isConfiguring = false;
 }
}


/**********************************************************************/
/********************  Ordinateur *************************************/
/**********************************************************************/
/*import processing.serial.*;
Serial myPort;  
String portName = Serial.list()[0];
String infoBT = "";

boolean bReleased = true; //no permament sending when finger is tap

char SerialRead(){
  char a;
 a = (char) myPort.read();         // Série
 infoBT += a;
 if (a=='\n') infoBT="";
return a;
} 

int BT_ava(){
  int i=0;
  if ( myPort.available() > 20) i=1;  // série
  return i;
}

void initBT()
{
  portName="/dev/ttyUSB0";
  //portName="/dev/rfcomm0";
  //portName=Serial.list()[0];
  myPort = new Serial(this, portName, 9600);
  //println(portName);
}

void mouseClicked()
{
  commande();
}

********************************************************************/
/********************** Gestion des boutons    **********************/
/********************************************************************/
Bouton[] bp = new Bouton[10];  

class Bouton
{
 int posx; int posy;
 int tailx=fzoom(90); 
 int taily=fzoom(70);
 int tcar=fzoom(20);  
 String nom;
 int cli=0;
 int bp_actif=0;
 
 Bouton(int x, int y,String txt)
 {
   posx=x;   
   posy=y;  
   nom=txt;   cli=0;
  } 

 void taille(int tx,int ty)
 {
   tailx= tx;   taily= ty;
 }   

 void dessine(int col,int colt)
 {
   int c=5;
   stroke(0);   strokeWeight(1);
   fill(color(200,200,200));   rect(posx+2,posy+2,tailx-2,taily-2,c);
   fill(col);   rect(posx,posy,tailx-2,taily-2,c);
   textSize(tcar);  fill(colt);   text(nom,10+posx,posy+taily/2-tcar/2-2,tailx,taily);
 } 

void dess_on(){
  dessine(color(255,50,50),color(255,255,255));
}

void dess_off(){
  dessine(color(255,255,255),color(0,0,0));
}

void dess_survol(){
  dessine(color(150,150,150),color(255,255,255));
}

int mousedans()
 {
   int i=1;
   if (mouseX<posx) i=0;   if (mouseY<posy)  i=0;   if (mouseX>posx+tailx) i=0;   if (mouseY>posy+taily) i=0;
   return i;
 }  

 void choix()
 {
   bp_actif=1;
   if (cli==1) dess_on();   else  dess_off();
 } 

int clic()
 {
   if (bp_actif==0) return(0);
   if (mousedans()==1)
   if (cli==0) cli=1; else cli=0;
   return(cli);   
 } 

} 



PImage img;
PFont fontMy;
float zoom=1;

int fzoom(int a){
 float c=a*zoom;
 return((int) c);
}


void setuptaille(){
  bp[0] = new Bouton(100,20,"zoom x1");
  bp[1] = new Bouton(100,120,"zoom x1.5");
  bp[2] = new Bouton(100,220,"zoom x2");
//  bp[3] = new Bouton(width-100,fzoom(230+80),"X / Z");
//  bp[4] = new Bouton(width-100,fzoom(230+160),"Y / Z");
}

int fin=0;

void config(){
 background(255,204,0);
  stroke(0);
  fill(0,0,0);
  textSize(fzoom(10));
  fontMy = createFont("SansSerif", 40);
 textFont(fontMy);
//setuptaille();
 
  bp[0] = new Bouton(width-fzoom(100),20,"RAZ");
  bp[1] = new Bouton(width-fzoom(100),fzoom(100),"Sens");
  bp[2] = new Bouton(width-fzoom(100),fzoom(230),"X / Y");
  bp[3] = new Bouton(width-fzoom(100),fzoom(230+80),"X / Z");
  bp[4] = new Bouton(width-fzoom(100),fzoom(230+160),"Y / Z");
 int a,b;
 int j;
 String st; 
 st = new String();
bp[2].cli=1; 
}



void setup() {
// size(800,480); zoom=1;
// size(1200,720); zoom=1.5;
   size(1600,1024); zoom=2; 
 initBT();
 orientation(2);
 img = loadImage("img1.png");

 config();
// ou setuptaille();
}

float gx=0,gy=0,gz,ga;
float sgx=0,sgy=0,sgz=0,sga=0;
float signe=1;
float signez=1;
String s="";
char val;

void mesure(){
  if ( BT_ava() > 0) {  // If data is available,
   val = SerialRead();         // read it and store it in val

    if (val=='x')
    {
      gx=0;
      s=""; signe=1;
      val = SerialRead();         // read =
      val = SerialRead();         // read signe +-
      if (val=='-') { signe=-1; }  
   while (val!=' ')
   {
      s=s+char(val); val = SerialRead();         // read it and store it in val
  } 
    gx=float(s);
//   sgx=(3*sgx+gx)/4;
   sgx=gx;
    } 

 
  if (val=='y')
    {
    gy=0;
    s=""; signe=1;
    val = SerialRead();         // read it and store it in val
    val = SerialRead();         // read it and store it in val
      if (val=='-') { signe=-1; }  
   while (val!=' ')
   {
      s=s+char(val); val = SerialRead();         // read it and store it in val
  } 
    gy=float(s);
   sgy=gy;
   //sgy=(3*sgy+gy)/4;
    }

     if (val=='z')
    {
    gz=0;
    s=""; signe=1;
    val = SerialRead();         // read it and store it in val
    val = SerialRead();         // read it and store it in val
     if (val=='-') { signe=-1; }  
   while (val!=' ')
   {
      s=s+char(val); val = SerialRead();         // read it and store it in val
  } 
    gz=float(s);
   sgz=gz;
    } 


/*
 if (val=='a')
    {
    ga=0;
    s=""; 
    val = SerialRead();         // read =
    val = SerialRead();         // 
   while (val!=' ')
   {
      s=s+char(val); val = SerialRead();         // read it and store it in val
  } 
    ga=float(s);
   sga=ga;
   }
*/
   }
//    print("x="+ gx + "  " );
//    print("y="+ gy + "  " );
//    println("a=" + ga  ); 
}

float cadranav=0;  
float angle_dec=0; // angle de décalage ( pour les tours )
float angle=0;
float angle_aff;
float razangle=0;
int u=0;



void draw() {
/*  if (fin==0)
  {
  for (int i=0; i<3; i++) {bp[i].choix(); }  
  return;
  }  
*/
 background(255,204,0);
 image(img, 3, 3);
 for (int i=0; i<=4; i++) {bp[i].choix(); }  
  mesure();
  float x=gx;
  float y=gy;
  float z=gz;

  if (bp[2].cli==1) {x=gx; y=gy; }
  if (bp[3].cli==1) {x=gz; y=gy; }
  if (bp[4].cli==1) {x=gx; y=gz; }
  
  if (u!=0) y=-y;
  float hyp=sqrt(x*x+y*y);
 
 float cadran=-1;
 angle = 360*acos(x/hyp)/(2*PI);
 if ((x>=0) && (y>=0)) cadran=1;
 if ((x<=0) && (y>=0)) cadran=2;
 if ((x<=0) && (y<=0)) cadran=3;
 if ((x>=0) && (y<=0)) cadran=4;
 if(cadran>2) angle=360-angle;
 
 if ((cadran==1) && (cadranav==4)) angle_dec+=360; 
 if ((cadran==4) && (cadranav==1)) angle_dec-=360; 
   
 cadranav=cadran;
 angle+=angle_dec;
 angle_aff=angle-razangle;
  fill(50,150,150,255);
  stroke(0);
  ellipse(width/2,height/2,2*height/3,2*height/3);   
  rect(width-fzoom(200),height-50,50,-hyp);
  stroke(0);
  strokeWeight(8);
  x=height/3*cos(2*PI*angle_aff/360);
  y=height/3*sin(2*PI*angle_aff/360);
  line(width/2,height/2,width/2+x,height/2-y);

  stroke(240);
  strokeWeight(1);
  x=height/3*cos(2*PI*angle/360);
  y=height/3*sin(2*PI*angle/360);
  if (u!=0) y=-y;
  line(width/2,height/2,width/2+x,height/2-y);

  strokeWeight(1);
  textSize(fzoom(20));
  fill(55, 55, 55, 204);
  text("0",width/2+height/3,height/2+fzoom(10),0);
 text("270",width/2-fzoom(20),height/2+height/3+fzoom(20),0);
 text("180",width/2-height/3-fzoom(40),height/2+fzoom(10),0);
 text("90",width/2-fzoom(20),height/2-height/3,0);
 
  strokeWeight(2);
  textSize(fzoom(20));
  fill(55, 55, 55, 204);
  text(cadran,15,30,0);
  textSize(fzoom(60));
  int a=int (angle_aff*10);
  int tr=int(angle_aff)/360;
//  float b=a;
  float b=a-tr*3600;
//  text(angle_aff,50,height-80,0);
  text(b/10,fzoom(50),height-fzoom(80),0);
  textSize(30);
  text("NB tour(s) : "+tr,fzoom(50),height-fzoom(140),0);
//  text(angle,15,50,0);
//  text(razangle,15,65,0);
  textSize(fzoom(12)); 
  fill(255);
  noStroke();
  textAlign(LEFT);
  text(infoBT, width/2, fzoom(20));  

}


void commande()
{
 /* if (fin==0){
  if (bp[0].clic()==1) { size(800,480); zoom=1; fin=1; bp[0].cli=0;}
  if (bp[1].clic()==1) { size(1200,720); zoom=1.5; fin=1; bp[1].cli=0;}
  if (bp[2].clic()==1) { size(1600,1024); zoom=2; fin=1;bp[2].cli=0;}
  if (fin==1) { config(); frame.setSize(width, height); frame.setResizable(true); }
  return;
  }
*/

  if (bp[0].clic()==1) { razangle+=angle_aff;}
  if (bp[1].clic()==1) u=1; else u=0;
  if (bp[2].clic()==1) { bp[3].cli=0;bp[4].cli=0;img = loadImage("img1.png");}
  if (bp[3].clic()==1) { bp[2].cli=0;bp[4].cli=0;img = loadImage("img2.png");}
  if (bp[4].clic()==1) { bp[3].cli=0;bp[2].cli=0;img = loadImage("img3.png");}
  bp[0].cli=0;
}  
